<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <link rel="stylesheet" href="css.css">
</head>
<nav class="navbar navbar-expand-lg navbar-light bg-light">
    <a class="navbar-brand" href="#">Navbar</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
  
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item active ">
          <a class="nav-link" href="#">Home <span class="sr-only">(current)</span></a>
          
        </li>
        <li class="nav-item">
          <a class="nav-link" href="#">Link</a>
        </li>
        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
            Dropdown
          </a>
          <div class="dropdown-menu" aria-labelledby="navbarDropdown">
            <a class="dropdown-item" href="#">Action</a>
            <a class="dropdown-item" href="#">Another action</a>
            <div class="dropdown-divider"></div>
            <a class="dropdown-item" href="#">Something else here</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link disabled" href="#">Disabled</a>
        </li>
      </ul>
      <form class="form-inline my-2 my-lg-0">
        <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search">
        <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
      </form>
    </div>
  </nav>
  <nav aria-label="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item"><a href="#">Home</a></li>
      <li class="breadcrumb-item" aria-current="page"><a href="#">List User</a></li>
    </ol>
  </nav>
  
  <div class="sidebar">
    <a class="active" href="#home">Home</a>
    <a href="#news">News</a>
    <a href="#contact">Contact</a>
    <a href="#about">About</a>
  </div>
<div class="container">
    <div class="row">
        <div class="col-sm-12 mb-3">
            <h4 class="text-center m-4"><b>DANH SÁCH ĐƠN HÀNG</b></h4>
            <div class="container jumbotron py-4">
                <div class="row form-group">
                  <label class="col-sm-2 col-form-label">Trạng thái Order:</label>
                  <div class="col-sm-3">
                    <select id="select-status" class="form-control">
                        <option value="all">All</option>
                        <option value="open">Open</option>
                        <option value="confirm">Confirm</option>
                        <option value="cancel">Cancel</option>
                    </select>
                  </div>
                  <label class="col-sm-2 col-form-label">Loại pizza:</label>
                  <div class="col-sm-3">
                    <select id="select-pizza" class="form-control">
                        <option value="all">All</option>
                        <option value="hawaii">Hawaii</option>
                        <option value="bacon">Bacon</option>
                        <option value="seafood">Seafood</option>
                    </select>
                  </div>
                  <div class="col-sm-2">
                    <button class="btn btn-primary" id="btn-filter">Lọc</button>
                  </div>
                </div>
              </div>
            <table id="tbl-order" class="table text-center table-hover table-bordered table-striped">
                <thead>
                  <tr>
                    <th scope="col">Order ID</th>
                    <th scope="col">Kích cỡ Combo</th>
                    <th scope="col">Loại pizza</th>
                    <th scope="col">Nước uống</th>
                    <th scope="col">Thành tiền</th>
                    <th scope="col">Họ và tên</th>
                    <th scope="col">Số điện thoại</th>
                    <th scope="col">Trạng thái</th>
                    <th scope="col">Chi tiết</th>
                  </tr>
                </thead>
                <tbody>
                  
                </tbody>
            </table>
        </div>
    </div>
</div>
<!-- Modal edit mới khóa học -->
<div>
  <div id="detail-course-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog modal-lg">
          <div class="modal-content">
          <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Order Detail!!!</h5>
              <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
              <form>
                <div class="col-10 mx-auto">
                  <div class="row form-group">
                    <label class="col-4">Order ID(mã đơn hàng):</label>
                    <input type="text" class="form-control col-8" id="input-orderid" placeholder="Order ID">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Có Combo:</label>
                    <input type="text" class="form-control col-8" id="input-combo" placeholder="Combo">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Đường kính:</label>
                    <input type="text" class="form-control col-8" id="input-duong-kinh" placeholder="Đường kính">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Sườn nướng(miếng):</label>
                    <input type="text" class="form-control col-8" id="input-suon" placeholder="Sườn nướng">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Đồ uống:</label>
                    <input type="text" class="form-control col-8" id="input-drink" placeholder="Đồ uống">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Số lượng nước uống:</label>
                    <input type="text" class="form-control col-8" id="input-drink-number" placeholder="Số lượng nước uống">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Voucher ID:</label>
                    <input type="text" class="form-control col-8" id="input-voucherid" placeholder="Voucher ID">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Loại pizza:</label>
                    <input type="text" class="form-control col-8" id="input-pizza" placeholder="Loại pizza">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Salad:</label>
                    <input type="text" class="form-control col-8" id="input-salad" placeholder="Salad">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Thành tiền:</label>
                    <input type="text" class="form-control col-8" id="input-tien" placeholder="Thành tiền">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Giảm giá:</label>
                    <input type="text" class="form-control col-8" id="input-giam-gia" placeholder="Giảm giá">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Họ và tên:</label>
                    <input type="text" class="form-control col-8" id="input-ho-ten" placeholder="Họ và tên">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Email:</label>
                    <input type="text" class="form-control col-8" id="input-email" placeholder="Email">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Số điện thoại:</label>
                    <input type="text" class="form-control col-8" id="input-so-dien-thoai" placeholder="Số điện thoại">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Địa chỉ:</label>
                    <input type="text" class="form-control col-8" id="input-dia-chi" placeholder="Địa chỉ">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Lời nhắn:</label>
                    <input type="text" class="form-control col-8" id="input-message" placeholder="Lời nhắn">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Trạng thái đơn hàng:</label>
                    <input type="text" class="form-control col-8" id="input-trang-thai" placeholder="Trạng thái">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Ngày tạo đơn:</label>
                    <input type="text" class="form-control col-8" id="input-ngay-tao" placeholder="Ngày tạo">
                  </div>
                  <div class="row form-group">
                    <label class="col-4">Ngày cập nhật:</label>
                    <input type="text" class="form-control col-8" id="input-ngay-cap-nhat" placeholder="Ngày cập nhật">
                  </div>
                </div>
              </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-info" id="btn-confirm">Confirm</button>
            <button class="btn btn-secondary" id="btn-cancel">Cancel</button>
          </div>
          </div>
      </div>
  </div>
</div>
  <!-- -->
    <!-- Site footer -->
    <footer class="site-footer">
      <div class="container">
        <div class="row">
          <div class="col-sm-12 col-md-6">
            <h6>About</h6>
            <p class="text-justify">Scanfcode.com <i>CODE WANTS TO BE SIMPLE </i> is an initiative  to help the upcoming programmers with the code. Scanfcode focuses on providing the most efficient code or snippets as the code wants to be simple. We will help programmers build up concepts in different programming languages that include C, C++, Java, HTML, CSS, Bootstrap, JavaScript, PHP, Android, SQL and Algorithm.</p>
          </div>

          <div class="col-xs-6 col-md-3">
            <h6>Categories</h6>
            <ul class="footer-links">
              <li><a href="http://scanfcode.com/category/c-language/">C</a></li>
              <li><a href="http://scanfcode.com/category/front-end-development/">UI Design</a></li>
              <li><a href="http://scanfcode.com/category/back-end-development/">PHP</a></li>
              <li><a href="http://scanfcode.com/category/java-programming-language/">Java</a></li>
              <li><a href="http://scanfcode.com/category/android/">Android</a></li>
              <li><a href="http://scanfcode.com/category/templates/">Templates</a></li>
            </ul>
          </div>

          <div class="col-xs-6 col-md-3">
            <h6>Quick Links</h6>
            <ul class="footer-links">
              <li><a href="http://scanfcode.com/about/">About Us</a></li>
              <li><a href="http://scanfcode.com/contact/">Contact Us</a></li>
              <li><a href="http://scanfcode.com/contribute-at-scanfcode/">Contribute</a></li>
              <li><a href="http://scanfcode.com/privacy-policy/">Privacy Policy</a></li>
              <li><a href="http://scanfcode.com/sitemap/">Sitemap</a></li>
            </ul>
          </div>
        </div>
        <hr>
      </div>
      <div class="container">
        <div class="row">
          <div class="col-md-8 col-sm-6 col-xs-12">
            <p class="copyright-text">Copyright &copy; 2017 All Rights Reserved by 
         <a href="#">Scanfcode</a>.
            </p>
          </div>

          <div class="col-md-4 col-sm-6 col-xs-12">
            <ul class="social-icons">
              <li><a class="facebook" href="#"><i class="fa fa-facebook"></i></a></li>
              <li><a class="twitter" href="#"><i class="fa fa-twitter"></i></a></li>
              <li><a class="dribbble" href="#"><i class="fa fa-dribbble"></i></a></li>
              <li><a class="linkedin" href="#"><i class="fa fa-linkedin"></i></a></li>   
            </ul>
          </div>
        </div>
      </div>
</footer>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gCOLUMN_ORDER_ID = 0;
    const gCOLUMN_COMBO = 1;
    const gCOLUMN_LOAI_PIZZA = 2;
    const gCOLUMN_NUOC_UONG = 3;
    const gCOLUMN_THANH_TIEN = 4 ;
    const gCOLUMN_HO_VA_TEN = 5;
    const gCOLUMN_SĐT = 6;
    const gCOLUMN_STATUS = 7;
    const gCOLUMN_ACTION = 8;

    const gORDERS_PROPERTIES = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"]
    
    // định nghĩa table  - chưa có data
    var gOrderTable = $("#tbl-order").DataTable( {
      // Khai báo các cột của datatable
      "columns" : [
          { "data" : gORDERS_PROPERTIES[gCOLUMN_ORDER_ID] },
          { "data" :  gORDERS_PROPERTIES[gCOLUMN_COMBO]},
          { "data" :  gORDERS_PROPERTIES[gCOLUMN_LOAI_PIZZA]},
          { "data" :  gORDERS_PROPERTIES[gCOLUMN_NUOC_UONG]},
          { "data" :  gORDERS_PROPERTIES[gCOLUMN_THANH_TIEN]},
          { "data" :  gORDERS_PROPERTIES[gCOLUMN_HO_VA_TEN]},
          { "data" :  gORDERS_PROPERTIES[gCOLUMN_SĐT]},
          { "data" :  gORDERS_PROPERTIES[gCOLUMN_STATUS]},
          { "data" :  gORDERS_PROPERTIES[gCOLUMN_ACTION]}
      ],
      // Ghi đè nội dung của cột action, chuyển thành button chi tiết
      "columnDefs": [ 
      {
          "targets": gCOLUMN_ACTION,
          "defaultContent": "<button class='btn btn-info btn-chi-tiet'>Chi tiết</button>"
      }]
    });

    //biến mảng lưu trữ danh sách order 
    var gOrderList = [];
    //biến lưu trữ id của order
    var gId = "";
    //biến lưu trữ orderId
    var gOrderId = "";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoading();

        //gán sự kiện cho nút Chi tiết
        $(document).on("click",".btn-chi-tiet", function(){
            onBtnChiTietClick(this);
        });
        //gán sự kiện cho nút Lọc
        $(document).on("click","#btn-filter", function(){
            onBtnFilterOrderClick();
        });
        //gán sự kiện cho nút Confirm
        $(document).on("click","#btn-confirm",function(){
          onBtnConfirmOrderClick();
        });
        //gán sự kiện cho nút Cancel
        $(document).on("click","#btn-cancel",function(){
          onBtnCancelOrderClick();
        });
    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý sự kiện khi tảu trang
    function onPageLoading(){
        //gọi hàm lấy toàn bộ danh sách order từ sever
        getAllOrderList();
        //gọi hàm load data order vào bảng
        loadDataToTable(gOrderList);
    }
    //hàm xử lý sự kiện cho nút Chi tiết
    function onBtnChiTietClick(paramBtn){
        console.log("%c Nút chi tiết được nhấn!","color:blue");
        //gọi hàm lấy dữ liệu của dòng được chọn và gán vào biến lưu trữ
        var vDataRow = getDataRowFromButton(paramBtn);
        //ghi thông tin Order ra console
        console.log(vDataRow);

        gId = vDataRow.id;
        gOrderId = vDataRow.orderCode;
        console.log("Id: " + gId);
        console.log("Order Id: " + gOrderId);

        //gọi hàm call Api để lấy ra Order được chọn và hiển thị lên form modal detail
        getOrderDetail(gOrderId);
        //hiển thị form modal chi tiết
        $("#detail-course-modal").modal("show");
    }
    //hàm xử lý sự kiện cho nút Lọc
    function onBtnFilterOrderClick(){
        //B0: khai báo đối tượng để lưu trữ dữ liệu trên form
      var vFilterObj = {
        trangThai: "",
        loaiPizza: ""
      }
      //B1: thu thập dữ liệu
      getFilterFormData(vFilterObj);
      //B2: validate dữ liệu(không yêu cầu)
      //B3: Xử lý lọc
      var vOrderResutl = filterOrder(vFilterObj);
      //B4: Hiển thị user lên bảng
      loadDataToTable(vOrderResutl);
    }
    //hàm xử lý sự kiện cho nút Confirm
    function onBtnConfirmOrderClick(){
      //biến lưu trữ trạng thái Confirm
      var vObjectRequest = {
            trangThai: "" 
      }
      console.log("%cNút Confirm được bấm","color: red");
      //lấy thông tin trạng thái từ form modal
      getStatusFromModal(vObjectRequest);
      //kiểm tra thông tin trạng thái
      if(validateStatusFromModal(vObjectRequest, "confirmed") == true){
        //gọi Api để cập nhật thông tin order theo id
        callApiToUpdateOrder(gId, vObjectRequest);
        //gọi Api lấy toàn bộ danh sách order
        getAllOrderList();
        //hiển thị lại list order vào DataTable
        loadDataToTable(gOrderList);
        //ẩn form modal sau khi cập nhật thành công
        $("#detail-course-modal").modal("hide");
      }
    }
    //hàm xử lý sự kiện cho nút Cancel
    function onBtnCancelOrderClick(){
      //biến lưu trữ trạng thái Confirm
      var vObjectRequest = {
            trangThai: "" 
      }
      console.log("%cNút Cancel được bấm","color: blue");
      //lấy thông tin trạng thái từ form modal
      getStatusFromModal(vObjectRequest);
      //kiểm tra thông tin trạng thái
      if(validateStatusFromModal(vObjectRequest, "cancel") == true){
        //gọi Api để cập nhật thông tin order theo id
        callApiToUpdateOrder(gId, vObjectRequest);
        //gọi Api lấy toàn bộ danh sách order
        getAllOrderList();
        //hiển thị lại list order vào DataTable
        loadDataToTable(gOrderList);
        //ẩn form modal sau khi cập nhật thành công
        $("#detail-course-modal").modal("hide");
      }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm gọi Api để lấy toàn bộ danh sách order
    function getAllOrderList(){
        $.ajax({
        url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
        type: "GET",
        dataType: 'json',
        async: false,
        success: function(responseObject){
          gOrderList = responseObject;
          console.log(gOrderList);
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });
    }
    //hàm gọi Api để lấy Order được chọn khi nhấn nút chi tiết
    function getOrderDetail(paramOrderId){
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-pizza365/orders" + "/" + paramOrderId,
        type: "GET",
        dataType: 'json',
        async: false,
        success: function(responseObject){
          //hiển thị thông tin order lên form Detail
          showDataOrderToModalDetail(responseObject);
          console.log(responseObject);
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });
    }
    //hàm gọi Api để cập nhật thông tin trạng thái
    function callApiToUpdateOrder(paramId, paramStatusObj){
      var vJsonString = JSON.stringify(paramStatusObj);
       
      $.ajax({
          url:  "http://203.171.20.210:8080/devcamp-pizza365/orders" + "/" + paramId,
          method: 'PUT',
          contentType: "application/json; charset=utf-8",
          data: vJsonString,
          async: false,
          success: function(paramResponse) {
            //thông báo cập nhật thành công
            alert("Cập nhật thông tin thành công!");
          },
          error: function (ajaxContext) {
            console.log(ajaxContext);
          }
      }); 
    }
    //hàm xử lý hiển thị data vào bảng
    function loadDataToTable(paramOrderObj) {
        //Xóa toàn bộ dữ liệu đang có của bảng
        gOrderTable.clear();
        //Cập nhật data cho bảng 
        gOrderTable.rows.add(paramOrderObj);
        //Cập nhật lại giao diện hiển thị bảng
        gOrderTable.draw();
    }
    // hàm lấy dữ liệu của row được chọn
    function getDataRowFromButton(paramButton) {
        var vTableRow = $(paramButton).parents("tr");
        var vRowData = gOrderTable.row(vTableRow).data();
        return vRowData;
    }
    //hàm lấy dữ liệu từ ô select trong form Lọc
    function getFilterFormData(paramFilterObj){
        paramFilterObj.trangThai = $("#select-status").val();
        paramFilterObj.loaiPizza = $("#select-pizza").val();
    }
    //hàm thực hiện lọc order trong mảng và trả về mảng order sau khi lọc thỏa mãn điều kiện
    function filterOrder(paramFilterObj){
        var vOrders = gOrderList.filter(function(paramOrder){
        return paramOrder.loaiPizza != null && paramOrder.trangThai != null 
                && (paramOrder.trangThai.toLowerCase().includes(paramFilterObj.trangThai)  || paramFilterObj.trangThai == "all" ) 
                && (paramOrder.loaiPizza.toLowerCase().includes(paramFilterObj.loaiPizza) || paramFilterObj.loaiPizza == "all");
      })
      return vOrders;
    }
    //hàm hiển thị thông tin Order được chọn lên form modal Detail
    function showDataOrderToModalDetail(paramOrderObj){
      $("#input-orderid").val(paramOrderObj.orderCode);
      $("#input-combo").val(paramOrderObj.kichCo);
      $("#input-duong-kinh").val(paramOrderObj.duongKinh);
      $("#input-suon").val(paramOrderObj.suon);
      $("#input-drink").val(paramOrderObj.idLoaiNuocUong);
      $("#input-drink-number").val(paramOrderObj.soLuongNuoc);
      $("#input-voucherid").val(paramOrderObj.idVourcher);
      $("#input-pizza").val(paramOrderObj.loaiPizza);
      $("#input-salad").val(paramOrderObj.salad);
      $("#input-tien").val(paramOrderObj.thanhTien);
      $("#input-giam-gia").val(paramOrderObj.giamGia);
      $("#input-ho-ten").val(paramOrderObj.hoTen);
      $("#input-email").val(paramOrderObj.email);
      $("#input-so-dien-thoai").val(paramOrderObj.soDienThoai);
      $("#input-dia-chi").val(paramOrderObj.diaChi);
      $("#input-message").val(paramOrderObj.loiNhan);
      $("#input-trang-thai").val(paramOrderObj.trangThai);
      $("#input-ngay-tao").val(paramOrderObj.ngayTao);
      $("#input-ngay-cap-nhat").val(paramOrderObj.ngayCapNhat);
    }
    //hàm lấy thông tin trạng thái từ ô input trạng thái
    function getStatusFromModal(paramStatusObj){
      paramStatusObj.trangThai = $("#input-trang-thai").val().trim();
    }
    //hàm kiểm tra dữ liệu trạng thái lấy từ ô input
    function validateStatusFromModal(paramStatusObj, paramStatus){
      if(paramStatus.includes(paramStatusObj.trangThai.toLowerCase())){
        return true;

      }else{
        alert("Trạng thái không hợp lệ!");
        return false;
      }
    }
</script>
</html>